#include <conio.h>


#define reg_joypad1 *(char*)0x4016
#define reg_joypad2 *(char*)0x4017

int main (void)
{   
	unsigned char a, olda;
	unsigned char b, oldb;
	unsigned char select, oldselect;
	unsigned char start, oldstart;
	unsigned char up, oldup;
	unsigned char down, olddown;
	unsigned char left, oldleft;
	unsigned char right, oldright;
	unsigned char i;


	/* Set bg color */

	bgcolor (COLOR_RED);
	

	//start by clearing all of the button state variables
	a = 0;
	olda = 0;
	b = 0;
	oldb = 0;
	select = 0;
	oldselect = 0;
	start = 0;
	oldstart = 0;
	up = 0;
	oldup = 0;
	down = 0;
	olddown = 0;
	left = 0;
	oldleft = 0;
	right = 0;
	oldright = 0;

	clrscr(); 
	cprintf ("Adventure Start!\n\rPress Start To Continue...\n\n\r");
	
	//strobe the joypad to reset it
	reg_joypad1 = 1;
	reg_joypad1 = 0;

	//check the signature, refer to the nes tech docs for more info on signatures
	for(i=1;i<21;i++)
	{
		a = reg_joypad1;
	}
	//if we get a "1" at this location, it indicates a joypad is connected to port 1. 

	if(a == 0x41)
	{
		cprintf("Joypad 1 Found\n\r");
	}
	a = 0;

	//strobe the joypad to reset it
	reg_joypad1 = 1;
	reg_joypad1 = 0;


	i = 1;
while(1)
{
	while (i == 1)
	{
		a = reg_joypad1;
		b = reg_joypad1;
		select = reg_joypad1;
		start = reg_joypad1;
		if((start == 0x41) && (oldstart == 0x40))
		{
		gotoxy(0,0);
		clrscr();

		cprintf("Splash! The sound of the rocking waves slowly bring you to your senses. The bright blue sky hangs quietly above with not a cloud or bird in sight. The throbbing pain in the back of your head certainily isn't helping anything. As the scene comes into focus you become acutely aware of the gentle sway of your surroundings.\n\n");
		gotox(0);
		cprintf("Press A to continue...\n
");
		i = 2;
		}
		//update the previous button state holders
		oldstart = start;

		//strobe the joypad again to reset it
		reg_joypad1 = 1;
		reg_joypad1 = 0;

	}

	while (i == 2)
	{
		a = reg_joypad1;
		if((a == 0x41) && (olda == 0x40))
		{
		gotoxy(0,0);
		clrscr();

		cprintf("Taking a quick look about you, you find yourself alone in the middle of a vast sea on a creaky wooden boat. Your throat feels like a sheet of 50 grit sandpaper. You need water and you need it fast.\n\n");
		gotox(0);
		cprintf("What are you going to do?\n\n");
		gotox(0);
		cprintf("A: Take a thorough inspection of the boat.\n\n");
		gotox(0);
		cprintf("B: Try drinking the water from the sea.\n\n");
		gotox(0);
		cprintf("Select: Take in your surroundings and try to find dry land.\n\n");
		gotox(0);
		cprintf("Start: Just sit and wait for help.\n\n");
		i = 3;
		}
		//update the previous button state holders
		olda = a;

		//strobe the joypad again to reset it
		reg_joypad1 = 1;
		reg_joypad1 = 0;

	}

	while (i == 3)
	{
		a = reg_joypad1;
		if((a == 0x41) && (olda == 0x40))
		{
		gotoxy(0,0);
		clrscr();
		
		cprintf("You find a water bottle!\n\rYou take a long refreshing drink of water and satisfy your thirst.\n\n\rVICTORY!\n\n\rPress A to continue...");
		i = 4;
		}

		b = reg_joypad1;
		if((b == 0x41) && (oldb == 0x40))
		{
		gotoxy(0,0);
		clrscr();

		cprintf("You take a sip of the seawater and spit it all out. The salty water does you no good and you remain as thirsty as ever.\n\n");
		gotox(0);
		cprintf("Press A to continue...\n
");

		i = 2;
		}

		select = reg_joypad1;
		if((select == 0x41) && (oldselect == 0x40))
		{
		gotoxy(0,0);
		clrscr();

		cprintf("You struggle to get up, hoping to find some dry land and a source of water. As your feeble legs buckle beneath you the world turns black and you collaspe.\n\n");
		gotox(0);
		cprintf("Press A to continue...\n
");
		i = 2;
		}

		start = reg_joypad1;
		if((start == 0x41) && (oldstart == 0x40))
		{
		gotoxy(0,0);
		clrscr();

		cprintf("So you sit. Bored out of your mind. With every moment that passes you get more and more thirsty. Eventually your HP whittles down to 0. Alas there is no Pheonix Down available.\n\n\rGAME OVER\n\n");
		gotox(0);
		cprintf("Press A to continue...\n
");
		i = 4;
		}

		//update the previous button state holders
		olda = a;
		oldb = b;
		oldselect = select;
		oldstart = start;

		//strobe the joypad again to reset it
		reg_joypad1 = 1;
		reg_joypad1 = 0;

	}

	while (i == 4)
	{
		a = reg_joypad1;
		if((a == 0x41) && (olda == 0x40))
		{
		gotoxy(0,0);
		clrscr();
		
		cprintf("Congratulations! You've finished the demo! Thrilling!\n\n\rPress A to restart...\n\n\rPress B to enter SECRET STAGE: Joypad testing");
		i = 5;
		}
		//update the previous button state holders
		olda = a;

		//strobe the joypad again to reset it
		reg_joypad1 = 1;
		reg_joypad1 = 0;
	}

	while (i == 5)
	{
		a = reg_joypad1;
		if((a == 0x41) && (olda == 0x40))
		{
		gotoxy(0,0);
		clrscr();
		cprintf ("Adventure Start!\n\rPress Start To Continue...\n\n\r");
		i = 1;
		}
		b = reg_joypad1;
		if((b == 0x41) && (oldb == 0x40))
		{
		gotoxy(0,0);
		clrscr();
		cprintf("Press any key...");
		i = 0;
		}
		//update the previous button state holders
		olda = a;
		oldb = b;

		//strobe the joypad again to reset it
		reg_joypad1 = 1;
		reg_joypad1 = 0;

	}


	while(i == 0)
	{
	//read joypad1 A button from $4016	
	a = reg_joypad1;
	if((a == 0x41) && (olda == 0x40))
	{
		gotoxy(0,0);
		clrscr();
		cprintf("A");
		
	}
	//read joypad1 B button from $4016
	b = reg_joypad1;
	if((b == 0x41) && (oldb == 0x40))
	{
		gotoxy(0,0);
		clrscr(); 
		cprintf("B");
		
	}
	//read joypad1 Select button from $4016
	select = reg_joypad1;
	if((select == 0x41) && (oldselect == 0x40))
	{
		gotoxy(0,0);
		clrscr(); 
		cprintf("Select");
		
	}
	//read joypad1 Start button from $4016
	start = reg_joypad1;
	if((start == 0x41) && (oldstart == 0x40))
	{
		gotoxy(0,0);
		clrscr(); 
		cprintf("Start");
		
	}
	//read joypad1 Up button from $4016
	up = reg_joypad1;
	if((up == 0x41) && (oldup == 0x40))
	{
		gotoxy(0,0);
		clrscr(); 
		cprintf("Up");
		
	}
	//read joypad1 Down button from $4016
	down = reg_joypad1;
	if((down == 0x41) && (olddown == 0x40))
	{
		gotoxy(0,0);
		clrscr(); 
		cprintf("Down");
		
	}
	//read joypad1 Left button from $4016
	left = reg_joypad1;
	if((left == 0x41) && (oldleft == 0x40))
	{
		gotoxy(0,0);	
		clrscr(); 
		cprintf("Left");
		
	}
	//read joypad1 Right button from $4016
	right = reg_joypad1;
	if((right == 0x41) && (oldright == 0x40))
	{
		gotoxy(0,0);	
		clrscr(); 
		cprintf("Right");
		
	}
		//update the previous button state holders
		olda = a;
		oldb = b;
		oldselect = select;
		oldstart = start;
		oldup = up;
		olddown = down;
		oldleft = left;
		oldright = right;

		//strobe the joypad again to reset it
		reg_joypad1 = 1;
		reg_joypad1 = 0;

	}
}
}