
// This array holds the pattern data for the ASCII characters [32..96]
// Original file: font.png
// Dimensions: 128 x 32 pixels, 16 x 4 tiles

// Tile #0 : ( column 0, row 0 ) 
// +--------+
// |........|
// |........|
// |........|
// |........|
// |........|
// |........|
// |........|
// |........|
// +--------+
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 

// Tile #1 : ( column 1, row 0 ) 
// +--------+
// |........|
// |...12...|
// |...12...|
// |...12...|
// |...12...|
// |...12...|
// |........|
// |...12...|
// +--------+
0x00, 0x10, 0x10, 0x10, 0x10, 0x10, 0x00, 0x10, 
0x00, 0x08, 0x08, 0x08, 0x08, 0x08, 0x00, 0x08, 

// Tile #2 : ( column 2, row 0 ) 
// +--------+
// |........|
// |..12.12.|
// |..12.12.|
// |...2.1..|
// |........|
// |........|
// |........|
// |........|
// +--------+
0x00, 0x24, 0x24, 0x04, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x12, 0x12, 0x10, 0x00, 0x00, 0x00, 0x00, 

// Tile #3 : ( column 3, row 0 ) 
// +--------+
// |........|
// |...12...|
// |..1112..|
// |.111112.|
// |11111112|
// |..1112..|
// |..1112..|
// |..1112..|
// +--------+
0x00, 0x10, 0x38, 0x7C, 0xFE, 0x38, 0x38, 0x38, 
0x00, 0x08, 0x04, 0x02, 0x01, 0x04, 0x04, 0x04, 

// Tile #4 : ( column 4, row 0 ) 
// +--------+
// |........|
// |..1112..|
// |..1112..|
// |..1112..|
// |11111112|
// |.111112.|
// |..1112..|
// |...12...|
// +--------+
0x00, 0x38, 0x38, 0x38, 0xFE, 0x7C, 0x38, 0x10, 
0x00, 0x04, 0x04, 0x04, 0x01, 0x02, 0x04, 0x08, 

// Tile #5 : ( column 5, row 0 ) 
// +--------+
// |........|
// |...12...|
// |...112..|
// |1111112.|
// |11111112|
// |1111112.|
// |...112..|
// |...12...|
// +--------+
0x00, 0x10, 0x18, 0xFC, 0xFE, 0xFC, 0x18, 0x10, 
0x00, 0x08, 0x04, 0x02, 0x01, 0x02, 0x04, 0x08, 

// Tile #6 : ( column 6, row 0 ) 
// +--------+
// |........|
// |...12...|
// |..112...|
// |.1111112|
// |11111112|
// |.1111112|
// |..112...|
// |...12...|
// +--------+
0x00, 0x10, 0x30, 0x7E, 0xFE, 0x7E, 0x30, 0x10, 
0x00, 0x08, 0x08, 0x01, 0x01, 0x01, 0x08, 0x08, 

// Tile #7 : ( column 7, row 0 ) 
// +--------+
// |........|
// |...12...|
// |...12...|
// |...1....|
// |........|
// |........|
// |........|
// |........|
// +--------+
0x00, 0x10, 0x10, 0x10, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x08, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 

// Tile #8 : ( column 8, row 0 ) 
// +--------+
// |........|
// |....12..|
// |...12...|
// |..12....|
// |..12....|
// |..12....|
// |...12...|
// |....12..|
// +--------+
0x00, 0x08, 0x10, 0x20, 0x20, 0x20, 0x10, 0x08, 
0x00, 0x04, 0x08, 0x10, 0x10, 0x10, 0x08, 0x04, 

// Tile #9 : ( column 9, row 0 ) 
// +--------+
// |........|
// |..12....|
// |...12...|
// |....12..|
// |....12..|
// |....12..|
// |...12...|
// |..12....|
// +--------+
0x00, 0x20, 0x10, 0x08, 0x08, 0x08, 0x10, 0x20, 
0x00, 0x10, 0x08, 0x04, 0x04, 0x04, 0x08, 0x10, 

// Tile #10 : ( column 10, row 0 ) 
// +--------+
// |........|
// |........|
// |.12.12..|
// |..112...|
// |1111112.|
// |..112...|
// |.12.12..|
// |........|
// +--------+
0x00, 0x00, 0x48, 0x30, 0xFC, 0x30, 0x48, 0x00, 
0x00, 0x00, 0x24, 0x08, 0x02, 0x08, 0x24, 0x00, 

// Tile #11 : ( column 11, row 0 ) 
// +--------+
// |........|
// |........|
// |...12...|
// |...12...|
// |.111112.|
// |...12...|
// |...12...|
// |........|
// +--------+
0x00, 0x00, 0x10, 0x10, 0x7C, 0x10, 0x10, 0x00, 
0x00, 0x00, 0x08, 0x08, 0x02, 0x08, 0x08, 0x00, 

// Tile #12 : ( column 12, row 0 ) 
// +--------+
// |........|
// |........|
// |........|
// |........|
// |........|
// |...12...|
// |...12...|
// |..12....|
// +--------+
0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x10, 0x20, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x08, 0x10, 

// Tile #13 : ( column 13, row 0 ) 
// +--------+
// |........|
// |........|
// |........|
// |........|
// |.111112.|
// |........|
// |........|
// |........|
// +--------+
0x00, 0x00, 0x00, 0x00, 0x7C, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 

// Tile #14 : ( column 14, row 0 ) 
// +--------+
// |........|
// |........|
// |........|
// |........|
// |........|
// |........|
// |...12...|
// |...12...|
// +--------+
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x10, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x08, 

// Tile #15 : ( column 15, row 0 ) 
// +--------+
// |........|
// |......1.|
// |.....12.|
// |....12..|
// |...12...|
// |..12....|
// |.12.....|
// |.2......|
// +--------+
0x00, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x00, 
0x00, 0x00, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 

// Tile #16 : ( column 0, row 1 ) 
// +--------+
// |........|
// |..112...|
// |.1..12..|
// |12...12.|
// |12...12.|
// |12...12.|
// |.12..1..|
// |..111...|
// +--------+
0x00, 0x30, 0x48, 0x84, 0x84, 0x84, 0x44, 0x38, 
0x00, 0x08, 0x04, 0x42, 0x42, 0x42, 0x20, 0x00, 

// Tile #17 : ( column 1, row 1 ) 
// +--------+
// |........|
// |...12...|
// |..112...|
// |...12...|
// |...12...|
// |...12...|
// |...12...|
// |.111112.|
// +--------+
0x00, 0x10, 0x30, 0x10, 0x10, 0x10, 0x10, 0x7C, 
0x00, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x02, 

// Tile #18 : ( column 2, row 1 ) 
// +--------+
// |........|
// |.11112..|
// |12...12.|
// |....112.|
// |..1112..|
// |.1112...|
// |112.....|
// |1111112.|
// +--------+
0x00, 0x78, 0x84, 0x0C, 0x38, 0x70, 0xC0, 0xFC, 
0x00, 0x04, 0x42, 0x02, 0x04, 0x08, 0x20, 0x02, 

// Tile #19 : ( column 3, row 1 ) 
// +--------+
// |........|
// |.111112.|
// |....12..|
// |...12...|
// |..1112..|
// |.....12.|
// |12...12.|
// |.11112..|
// +--------+
0x00, 0x7C, 0x08, 0x10, 0x38, 0x04, 0x84, 0x78, 
0x00, 0x02, 0x04, 0x08, 0x04, 0x02, 0x42, 0x04, 

// Tile #20 : ( column 4, row 1 ) 
// +--------+
// |........|
// |...112..|
// |..1212..|
// |.12.12..|
// |12..12..|
// |1111112.|
// |....12..|
// |....12..|
// +--------+
0x00, 0x18, 0x28, 0x48, 0x88, 0xFC, 0x08, 0x08, 
0x00, 0x04, 0x14, 0x24, 0x44, 0x02, 0x04, 0x04, 

// Tile #21 : ( column 5, row 1 ) 
// +--------+
// |........|
// |111112..|
// |12......|
// |111112..|
// |.....12.|
// |.....12.|
// |12...12.|
// |.11112..|
// +--------+
0x00, 0xF8, 0x80, 0xF8, 0x04, 0x04, 0x84, 0x78, 
0x00, 0x04, 0x40, 0x04, 0x02, 0x02, 0x42, 0x04, 

// Tile #22 : ( column 6, row 1 ) 
// +--------+
// |........|
// |..1112..|
// |.12.....|
// |12......|
// |111112..|
// |12...12.|
// |12...12.|
// |.11112..|
// +--------+
0x00, 0x38, 0x40, 0x80, 0xF8, 0x84, 0x84, 0x78, 
0x00, 0x04, 0x20, 0x40, 0x04, 0x42, 0x42, 0x04, 

// Tile #23 : ( column 7, row 1 ) 
// +--------+
// |........|
// |1111112.|
// |12...12.|
// |....12..|
// |...12...|
// |..12....|
// |..12....|
// |..12....|
// +--------+
0x00, 0xFC, 0x84, 0x08, 0x10, 0x20, 0x20, 0x20, 
0x00, 0x02, 0x42, 0x04, 0x08, 0x10, 0x10, 0x10, 

// Tile #24 : ( column 8, row 1 ) 
// +--------+
// |........|
// |.1112...|
// |12..12..|
// |12..12..|
// |.1112...|
// |12.2112.|
// |12...12.|
// |.11111..|
// +--------+
0x00, 0x70, 0x88, 0x88, 0x70, 0x8C, 0x84, 0x7C, 
0x00, 0x08, 0x44, 0x44, 0x08, 0x52, 0x42, 0x00, 

// Tile #25 : ( column 9, row 1 ) 
// +--------+
// |........|
// |.11112..|
// |12...12.|
// |12...12.|
// |.111112.|
// |.....12.|
// |....12..|
// |.1112...|
// +--------+
0x00, 0x78, 0x84, 0x84, 0x7C, 0x04, 0x08, 0x70, 
0x00, 0x04, 0x42, 0x42, 0x02, 0x02, 0x04, 0x08, 

// Tile #26 : ( column 10, row 1 ) 
// +--------+
// |........|
// |........|
// |...12...|
// |...12...|
// |........|
// |...12...|
// |...12...|
// |..12....|
// +--------+
0x00, 0x00, 0x10, 0x10, 0x00, 0x10, 0x10, 0x20, 
0x00, 0x00, 0x08, 0x08, 0x00, 0x08, 0x08, 0x10, 

// Tile #27 : ( column 11, row 1 ) 
// +--------+
// |........|
// |........|
// |...12...|
// |...12...|
// |........|
// |...12...|
// |...12...|
// |........|
// +--------+
0x00, 0x00, 0x10, 0x10, 0x00, 0x10, 0x10, 0x00, 
0x00, 0x00, 0x08, 0x08, 0x00, 0x08, 0x08, 0x00, 

// Tile #28 : ( column 12, row 1 ) 
// +--------+
// |........|
// |....12..|
// |...12...|
// |..12....|
// |.12.....|
// |..12....|
// |...12...|
// |....12..|
// +--------+
0x00, 0x08, 0x10, 0x20, 0x40, 0x20, 0x10, 0x08, 
0x00, 0x04, 0x08, 0x10, 0x20, 0x10, 0x08, 0x04, 

// Tile #29 : ( column 13, row 1 ) 
// +--------+
// |........|
// |........|
// |........|
// |..1112..|
// |........|
// |..1112..|
// |........|
// |........|
// +--------+
0x00, 0x00, 0x00, 0x38, 0x00, 0x38, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00, 

// Tile #30 : ( column 14, row 1 ) 
// +--------+
// |........|
// |..12....|
// |...12...|
// |....12..|
// |.....12.|
// |....12..|
// |...12...|
// |..12....|
// +--------+
0x00, 0x20, 0x10, 0x08, 0x04, 0x08, 0x10, 0x20, 
0x00, 0x10, 0x08, 0x04, 0x02, 0x04, 0x08, 0x10, 

// Tile #31 : ( column 15, row 1 ) 
// +--------+
// |........|
// |.11112..|
// |12...12.|
// |.....12.|
// |...112..|
// |..112...|
// |........|
// |..112...|
// +--------+
0x00, 0x78, 0x84, 0x04, 0x18, 0x30, 0x00, 0x30, 
0x00, 0x04, 0x42, 0x02, 0x04, 0x08, 0x00, 0x08, 

// Tile #32 : ( column 0, row 2 ) 
// +--------+
// |........|
// |.11112..|
// |12..112.|
// |12.12.12|
// |12.12.12|
// |12..112.|
// |12......|
// |.111112.|
// +--------+
0x00, 0x78, 0x8C, 0x92, 0x92, 0x8C, 0x80, 0x7C, 
0x00, 0x04, 0x42, 0x49, 0x49, 0x42, 0x40, 0x02, 

// Tile #33 : ( column 1, row 2 ) 
// +--------+
// |........|
// |..112...|
// |.12.12..|
// |12...12.|
// |12...12.|
// |1111112.|
// |12...12.|
// |12...12.|
// +--------+
0x00, 0x30, 0x48, 0x84, 0x84, 0xFC, 0x84, 0x84, 
0x00, 0x08, 0x24, 0x42, 0x42, 0x02, 0x42, 0x42, 

// Tile #34 : ( column 2, row 2 ) 
// +--------+
// |........|
// |111112..|
// |12...12.|
// |12...12.|
// |111112..|
// |12...12.|
// |12...12.|
// |111112..|
// +--------+
0x00, 0xF8, 0x84, 0x84, 0xF8, 0x84, 0x84, 0xF8, 
0x00, 0x04, 0x42, 0x42, 0x04, 0x42, 0x42, 0x04, 

// Tile #35 : ( column 3, row 2 ) 
// +--------+
// |........|
// |..1112..|
// |.12..12.|
// |12......|
// |12......|
// |12......|
// |.12..12.|
// |..1112..|
// +--------+
0x00, 0x38, 0x44, 0x80, 0x80, 0x80, 0x44, 0x38, 
0x00, 0x04, 0x22, 0x40, 0x40, 0x40, 0x22, 0x04, 

// Tile #36 : ( column 4, row 2 ) 
// +--------+
// |........|
// |11112...|
// |12..12..|
// |12...12.|
// |12...12.|
// |12...12.|
// |12..12..|
// |11112...|
// +--------+
0x00, 0xF0, 0x88, 0x84, 0x84, 0x84, 0x88, 0xF0, 
0x00, 0x08, 0x44, 0x42, 0x42, 0x42, 0x44, 0x08, 

// Tile #37 : ( column 5, row 2 ) 
// +--------+
// |........|
// |1111112.|
// |12......|
// |12......|
// |111112..|
// |12......|
// |12......|
// |1111112.|
// +--------+
0x00, 0xFC, 0x80, 0x80, 0xF8, 0x80, 0x80, 0xFC, 
0x00, 0x02, 0x40, 0x40, 0x04, 0x40, 0x40, 0x02, 

// Tile #38 : ( column 6, row 2 ) 
// +--------+
// |........|
// |1111112.|
// |12......|
// |12......|
// |111112..|
// |12......|
// |12......|
// |12......|
// +--------+
0x00, 0xFC, 0x80, 0x80, 0xF8, 0x80, 0x80, 0x80, 
0x00, 0x02, 0x40, 0x40, 0x04, 0x40, 0x40, 0x40, 

// Tile #39 : ( column 7, row 2 ) 
// +--------+
// |........|
// |..11112.|
// |.12.....|
// |12......|
// |12..112.|
// |12...12.|
// |.12..12.|
// |..11112.|
// +--------+
0x00, 0x3C, 0x40, 0x80, 0x8C, 0x84, 0x44, 0x3C, 
0x00, 0x02, 0x20, 0x40, 0x42, 0x42, 0x22, 0x02, 

// Tile #40 : ( column 8, row 2 ) 
// +--------+
// |........|
// |12...12.|
// |12...12.|
// |12...12.|
// |1111112.|
// |12...12.|
// |12...12.|
// |12...12.|
// +--------+
0x00, 0x84, 0x84, 0x84, 0xFC, 0x84, 0x84, 0x84, 
0x00, 0x42, 0x42, 0x42, 0x02, 0x42, 0x42, 0x42, 

// Tile #41 : ( column 9, row 2 ) 
// +--------+
// |........|
// |.111112.|
// |...12...|
// |...12...|
// |...12...|
// |...12...|
// |...12...|
// |.111112.|
// +--------+
0x00, 0x7C, 0x10, 0x10, 0x10, 0x10, 0x10, 0x7C, 
0x00, 0x02, 0x08, 0x08, 0x08, 0x08, 0x08, 0x02, 

// Tile #42 : ( column 10, row 2 ) 
// +--------+
// |........|
// |.....12.|
// |.....12.|
// |.....12.|
// |.....12.|
// |.....12.|
// |12...12.|
// |.11112..|
// +--------+
0x00, 0x04, 0x04, 0x04, 0x04, 0x04, 0x84, 0x78, 
0x00, 0x02, 0x02, 0x02, 0x02, 0x02, 0x42, 0x04, 

// Tile #43 : ( column 11, row 2 ) 
// +--------+
// |........|
// |12...12.|
// |12..12..|
// |12.12...|
// |1112....|
// |11112...|
// |12.112..|
// |12..112.|
// +--------+
0x00, 0x84, 0x88, 0x90, 0xE0, 0xF0, 0x98, 0x8C, 
0x00, 0x42, 0x44, 0x48, 0x10, 0x08, 0x44, 0x42, 

// Tile #44 : ( column 12, row 2 ) 
// +--------+
// |........|
// |12......|
// |12......|
// |12......|
// |12......|
// |12......|
// |12......|
// |1111112.|
// +--------+
0x00, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0xFC, 
0x00, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x02, 

// Tile #45 : ( column 13, row 2 ) 
// +--------+
// |........|
// |12...12.|
// |112.112.|
// |1111112.|
// |1111112.|
// |12.1.12.|
// |12...12.|
// |12...12.|
// +--------+
0x00, 0x84, 0xCC, 0xFC, 0xFC, 0x94, 0x84, 0x84, 
0x00, 0x42, 0x22, 0x02, 0x02, 0x42, 0x42, 0x42, 

// Tile #46 : ( column 14, row 2 ) 
// +--------+
// |........|
// |12...12.|
// |112..12.|
// |1112.12.|
// |1111112.|
// |12.1112.|
// |12..112.|
// |12...12.|
// +--------+
0x00, 0x84, 0xC4, 0xE4, 0xFC, 0x9C, 0x8C, 0x84, 
0x00, 0x42, 0x22, 0x12, 0x02, 0x42, 0x42, 0x42, 

// Tile #47 : ( column 15, row 2 ) 
// +--------+
// |........|
// |.11112..|
// |12...12.|
// |12...12.|
// |12...12.|
// |12...12.|
// |12...12.|
// |.11112..|
// +--------+
0x00, 0x78, 0x84, 0x84, 0x84, 0x84, 0x84, 0x78, 
0x00, 0x04, 0x42, 0x42, 0x42, 0x42, 0x42, 0x04, 

// Tile #48 : ( column 0, row 3 ) 
// +--------+
// |........|
// |111112..|
// |12...12.|
// |12...12.|
// |12...12.|
// |111112..|
// |12......|
// |12......|
// +--------+
0x00, 0xF8, 0x84, 0x84, 0x84, 0xF8, 0x80, 0x80, 
0x00, 0x04, 0x42, 0x42, 0x42, 0x04, 0x40, 0x40, 

// Tile #49 : ( column 1, row 3 ) 
// +--------+
// |........|
// |.11112..|
// |12...12.|
// |12...12.|
// |12...12.|
// |12.1212.|
// |12..11..|
// |.1112.1.|
// +--------+
0x00, 0x78, 0x84, 0x84, 0x84, 0x94, 0x8C, 0x72, 
0x00, 0x04, 0x42, 0x42, 0x42, 0x4A, 0x40, 0x08, 

// Tile #50 : ( column 2, row 3 ) 
// +--------+
// |........|
// |111112..|
// |12...12.|
// |12...12.|
// |12..112.|
// |11112...|
// |12.112..|
// |12..112.|
// +--------+
0x00, 0xF8, 0x84, 0x84, 0x8C, 0xF0, 0x98, 0x8C, 
0x00, 0x04, 0x42, 0x42, 0x42, 0x08, 0x44, 0x42, 

// Tile #51 : ( column 3, row 3 ) 
// +--------+
// |........|
// |.11112..|
// |12...12.|
// |12......|
// |.11112..|
// |.....12.|
// |12...12.|
// |.11112..|
// +--------+
0x00, 0x78, 0x84, 0x80, 0x78, 0x04, 0x84, 0x78, 
0x00, 0x04, 0x42, 0x40, 0x04, 0x02, 0x42, 0x04, 

// Tile #52 : ( column 4, row 3 ) 
// +--------+
// |........|
// |111112..|
// |..12....|
// |..12....|
// |..12....|
// |..12....|
// |..12....|
// |..12....|
// +--------+
0x00, 0xF8, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 
0x00, 0x04, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 

// Tile #53 : ( column 5, row 3 ) 
// +--------+
// |........|
// |12...12.|
// |12...12.|
// |12...12.|
// |12...12.|
// |12...12.|
// |12...12.|
// |.11112..|
// +--------+
0x00, 0x84, 0x84, 0x84, 0x84, 0x84, 0x84, 0x78, 
0x00, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x04, 

// Tile #54 : ( column 6, row 3 ) 
// +--------+
// |........|
// |12...12.|
// |12...12.|
// |12...12.|
// |12...12.|
// |.12.12..|
// |..112...|
// |...1....|
// +--------+
0x00, 0x84, 0x84, 0x84, 0x84, 0x48, 0x30, 0x10, 
0x00, 0x42, 0x42, 0x42, 0x42, 0x24, 0x08, 0x00, 

// Tile #55 : ( column 7, row 3 ) 
// +--------+
// |........|
// |12...12.|
// |12...12.|
// |12.1.12.|
// |1111112.|
// |1111112.|
// |.12.11..|
// |.1...1..|
// +--------+
0x00, 0x84, 0x84, 0x94, 0xFC, 0xFC, 0x4C, 0x44, 
0x00, 0x42, 0x42, 0x42, 0x02, 0x02, 0x20, 0x00, 

// Tile #56 : ( column 8, row 3 ) 
// +--------+
// |........|
// |12...12.|
// |112.112.|
// |.11112..|
// |..112...|
// |.11112..|
// |112.112.|
// |12...12.|
// +--------+
0x00, 0x84, 0xCC, 0x78, 0x30, 0x78, 0xCC, 0x84, 
0x00, 0x42, 0x22, 0x04, 0x08, 0x04, 0x22, 0x42, 

// Tile #57 : ( column 9, row 3 ) 
// +--------+
// |........|
// |.12..12.|
// |.12..12.|
// |.12..12.|
// |..1112..|
// |...12...|
// |...12...|
// |...12...|
// +--------+
0x00, 0x44, 0x44, 0x44, 0x38, 0x10, 0x10, 0x10, 
0x00, 0x22, 0x22, 0x22, 0x04, 0x08, 0x08, 0x08, 

// Tile #58 : ( column 10, row 3 ) 
// +--------+
// |........|
// |1111112.|
// |....112.|
// |...112..|
// |..112...|
// |.112....|
// |112.....|
// |1111112.|
// +--------+
0x00, 0xFC, 0x0C, 0x18, 0x30, 0x60, 0xC0, 0xFC, 
0x00, 0x02, 0x02, 0x04, 0x08, 0x10, 0x20, 0x02, 

// Tile #59 : ( column 11, row 3 ) 
// +--------+
// |........|
// |..1112..|
// |..12....|
// |..12....|
// |..12....|
// |..12....|
// |..12....|
// |..1112..|
// +--------+
0x00, 0x38, 0x20, 0x20, 0x20, 0x20, 0x20, 0x38, 
0x00, 0x04, 0x10, 0x10, 0x10, 0x10, 0x10, 0x04, 

// Tile #60 : ( column 12, row 3 ) 
// +--------+
// |........|
// |.2......|
// |.12.....|
// |..12....|
// |...12...|
// |....12..|
// |.....12.|
// |......1.|
// +--------+
0x00, 0x00, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 
0x00, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x00, 

// Tile #61 : ( column 13, row 3 ) 
// +--------+
// |........|
// |..1112..|
// |....12..|
// |....12..|
// |....12..|
// |....12..|
// |....12..|
// |..1112..|
// +--------+
0x00, 0x38, 0x08, 0x08, 0x08, 0x08, 0x08, 0x38, 
0x00, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 

// Tile #62 : ( column 14, row 3 ) 
// +--------+
// |........|
// |...12...|
// |..1112..|
// |.12..12.|
// |........|
// |........|
// |........|
// |........|
// +--------+
0x00, 0x10, 0x38, 0x44, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x08, 0x04, 0x22, 0x00, 0x00, 0x00, 0x00, 

// Tile #63 : ( column 15, row 3 ) 
// +--------+
// |........|
// |........|
// |........|
// |........|
// |........|
// |........|
// |........|
// |1111112.|
// +--------+
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 

